package com.example.greenwatch.alarmrecorder.runnables;

import android.media.MediaRecorder;
import android.view.SurfaceHolder;
import android.widget.Toast;

import com.example.greenwatch.MainActivity;

import java.io.IOException;

public class AudioRecorder implements Runnable {

    private MediaRecorder audioRecorder;
    private String audioPath;
    public AudioRecorder() {
        audioRecorder = new MediaRecorder();
    }

    public void setAudioPath(String audioPath) {
        this.audioPath = audioPath;
    }

    public void stopAudioRecording(){
        if (audioRecorder != null) {
            audioRecorder.stop();
            audioRecorder.reset();
            audioRecorder.release();
            audioRecorder = null;
        }
    }

    @Override
    public void run() {
        audioRecorder = new MediaRecorder();
        audioRecorder.setAudioSource(MediaRecorder.AudioSource.DEFAULT);
        audioRecorder.setOutputFormat(MediaRecorder.OutputFormat.MPEG_4);
        audioRecorder.setAudioEncoder(MediaRecorder.AudioEncoder.AAC);
        audioRecorder.setOutputFile(audioPath);

        try {
            audioRecorder.prepare();
            audioRecorder.start();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }
}
